var spawn = require('child_process').spawn;
var exec = require('child_process').exec;
var util = require('util');
var net = require('net');
var fs = require('fs');
var dns = require('dns');
var os = require('os');
var packageInfo = require('../package.json');
var is64Bit = os.arch() === 'x64' || process.env.hasOwnProperty('PROCESSOR_ARCHITEW6432');
var pltArch = is64Bit ? 64 : 32;

var path = fs.realpathSync('.');

var keypassword = false;
var thispid = false;
var connectingopenvpn = false;
var apidomain, apiip,vpnip;
var ostype = process.platform;
if(ostype == 'win32') {
    var Lazy = require('lazy');
}
var shapes;
var shapeenable = false;
var gateway = false;
var serverip = false;
var socketconn = false;
var obfsproxy = false;
var ipv6disabled = false;
var ipv6off = 'networksetup -listallnetworkservices | while read i; do SUPPORT=$(networksetup -getinfo "$i" | grep "IPv6: Automatic") && if [ -n "$SUPPORT" ]; then networksetup -setv6off "$i"; fi; done;';
var ipv6on = 'networksetup -listallnetworkservices | while read i; do SUPPORT=$(networksetup -getinfo "$i" | grep "IPv6: Off") && if [ -n "$SUPPORT" ]; then networksetup -setv6automatic "$i"; fi; done;';
if(pltArch == 64) {
    shapes = 'shapeshifter-dispatcher.exe'
}if(pltArch == 32) {
    shapes = 'shapeshifter-dispatcher-32.exe'
}

function OpenvpnClient(o) {
   
    if(connectingopenvpn) {
        return;
    }
    openvpnLogFile = fs.createWriteStream(path + '/openvpn.log', {'flags': 'a'})
    //fs.truncate(path + '/openvpn.log', 0, function(err){ console.log(err); });
    console.log(o);
    this.protect = o.pro;
    this.interDisable = o.disable;
    this.gateway = o.gateway;
    gateway = o.gateway;
    console.log('Gateway :' + o.gateway);
    this.dir = __dirname;
    var self = this;
    this.servername = o.server;
    this.connected = o.openvpnConnected;
    this.connecting = o.oconnecting;
    this.proto = o.proto;
    this.username = o.username;
    this.config = o.ovpn;
    this.line = 0;
    this.buffer = null;
    this.password = o.password;
    this.server = o.address;
    server = o.address;
    
    this.ostype = process.platform;
    this.port = o.port;
    this.openvpnno = o.openvpno;
    this.apiip = o.apiip;
    this.obfs = o.obfs;
    this.ipv6 = o.ipv6;
    this.cipher = window.localStorage.getItem('cipher');

    if(this.cipher != 'DES-CBC' && !this.obfs) {
        if(this.cipher == 'AES-128-CBC') {
            if(this.proto == 'udp') {
                this.port = '1281';
            }
            if(this.proto == 'tcp') {
                this.port = '109';
            }
        }
        if(this.cipher == 'AES-256-CBC') {
            if(this.proto == 'udp') {
                this.port = '1282';
            }
            if(this.proto == 'tcp') {
                this.port = '110';
            }
        }
    }
    if(this.obfs) {
        //OpenVPN 2.4+ will now auto upgrade to AES-128-GCM
        this.cipher = 'DES-CBC';
    }
    switch(this.ostype) {
        case 'linux':
            this.dnsleakfix = o.dnsleak;
            this.config = 'default.ovpn';
            if(this.obfs) {
                if(shapeenable == true) {
                    this.openvpnObj = ['/usr/sbin/openvpn', '--config',__dirname+'/config/'+this.config,'--cipher',this.cipher,'--remote','127.0.0.1', '1050','--proto',this.proto, '--ca', __dirname+'/config/ca.crt', '--cert', __dirname+'/config/' + this.username + '.crt', '--key', __dirname+'/config/' + this.username + '.key', '--auth-nocache','--script-security', '2'];
                } else {
                    this.openvpnObj = ['/usr/sbin/openvpn', '--config',__dirname+'/config/'+this.config,'--cipher',this.cipher,'--remote',this.server, this.port,'--proto',this.proto, '--ca', __dirname+'/config/ca.crt', '--cert', __dirname+'/config/' + this.username + '.crt', '--key', __dirname+'/config/' + this.username + '.key', '--auth-nocache','--script-security', '2'];
                }
            } else {
                this.openvpnObj = ['/usr/sbin/openvpn', '--config',__dirname+'/config/'+this.config,'--cipher',this.cipher,'--remote',this.server, this.port,'--proto',this.proto, '--ca', __dirname+'/config/ca.crt', '--cert', __dirname+'/config/' + this.username + '.crt', '--key', __dirname+'/config/' + this.username + '.key', '--auth-nocache','--script-security', '2'];
            }
        break;
        case 'darwin':
            this.config = 'default.ovpn';
            if(this.obfs) {
                if(shapeenable  == true) {
                    this.openvpnObj = ['./lib/bin/osx/openvpn', '--config',__dirname+'/config/'+this.config,'--cipher',this.cipher,'--remote','127.0.0.1', '1050','--proto',this.proto, '--ca', './lib/config/ca.crt', '--cert', './lib/config/' + this.username + '.crt', '--key', './lib/config/' + this.username + '.key', '--up', './lib/bin/osx/client.up.sh -z', '--down', './lib/bin/osx/client.down.sh', '--up-restart','--auth-nocache', '--script-security', '2'];
                } else {
                    this.openvpnObj = ['./lib/bin/osx/openvpn', '--config',__dirname+'/config/'+this.config,'--cipher',this.cipher,'--remote',this.server, this.port,'--proto',this.proto, '--ca', './lib/config/ca.crt', '--cert', './lib/config/' + this.username + '.crt', '--key', './lib/config/' + this.username + '.key', '--up', './lib/bin/osx/client.up.sh -z', '--down', './lib/bin/osx/client.down.sh', '--up-restart','--auth-nocache', '--script-security', '2'];
                }
            } else {
                this.openvpnObj = ['./lib/bin/osx/openvpn', '--config',__dirname+'/config/'+this.config,'--cipher',this.cipher,'--remote',this.server, this.port,'--proto',this.proto, '--ca', './lib/config/ca.crt', '--cert', './lib/config/' + this.username + '.crt', '--key', './lib/config/' + this.username + '.key', '--up', './lib/bin/osx/client.up.sh -z', '--down', './lib/bin/osx/client.down.sh', '--up-restart','--auth-nocache', '--script-security', '2'];
            }
            console.log('./lib/bin/osx/openvpn', '--config',__dirname+'/config/'+this.config,'--cipher',this.cipher,'--remote',this.server, this.port,'--proto',this.proto, '--ca', './lib/config/ca.crt', '--cert', './lib/config/' + this.username + '.crt', '--key', './lib/config/' + this.username + '.key', '--up', './lib/bin/osx/client.up.sh -z', '--down', './lib/bin/osx/client.down.sh', '--up-restart');
        break;
        case 'win32':
            //spawn('cmd', ['\/c', fs.realpathSync('.') + '.\\lib\\bin\\windows\\unidentified.bat']);
            this.config = 'default.ovpn';
            this.dnsleakfix = o.dnsleak;
            if(this.obfs) {
                if(shapeenable  == true) {
                    this.openvpnObj = ['--config',this.dir+'\\config\\'+this.config,'--cipher',this.cipher,'--remote','127.0.0.1', '1050','--proto',this.proto, '--ca', this.dir+'\\config\\ca.crt', '--cert', this.dir+'\\config\\' + this.username + '.crt', '--key', this.dir+'\\config\\' + this.username + '.key', '--auth-nocache'];
                } else {
                    this.openvpnObj = ['--config',this.dir+'\\config\\'+this.config,'--cipher',this.cipher,'--remote',this.server, this.port,'--proto',this.proto, '--ca', this.dir+'\\config\\ca.crt', '--cert', this.dir+'\\config\\' + this.username + '.crt', '--key', this.dir+'\\config\\' + this.username + '.key', '--auth-nocache'];
                }
            } else {
                this.openvpnObj = ['--config',this.dir+'\\config\\'+this.config,'--cipher',this.cipher,'--remote',this.server, this.port,'--proto',this.proto, '--ca', this.dir+'\\config\\ca.crt', '--cert', this.dir+'\\config\\' + this.username + '.crt', '--key', this.dir+'\\config\\' + this.username + '.key', '--auth-nocache'];
            }
        break;
    }

    this.getvpnIP = function(cb) {
        cb(vpnip);
    }

    console.log('before connect' +this.openvpnObj);


    this.connect = function() {
        console.log('hit connect');
        if (this.connected) {
            disconnectOpenVPN();
            checkLogfile();
            keypassword=false;
            
            return;

        }

        if(this.interDisable) {
            console.log('process disconnect');
            switch(this.ostype) {
                case 'linux':
                    spawn('sudo', ['route', 'add', 'default', 'gw', this.gateway]);
                    spawn('sudo', ['route','del', '-host', apiip, 'gw', this.gateway]);
                case 'darwin':
                    spawn('sudo', ['route', 'add', 'default', this.gateway]);
                    spawn('sudo', ['route','delete', '-net', apiip, '-gateway', this.gateway]);
                break;
                case 'win32':
                    spawn('route.exe', ['-p', 'add', '0.0.0.0', 'mask', '0.0.0.0', this.gateway]);
                    spawn('route.exe', ['delete', apiip, 'mask', '255.255.255.255']);
                break;
            }
        }
        console.log('connect ' + this.servername);
        connectingopenvpn = true;
        keypassword = true;
        util.log('Connecting to '+ this.server);
            switch(this.ostype) {
            case 'linux':
                if(this.openvpnno) {
                        console.log('openvpn options');
                        var index;
                        for (index = 0; index < o.openvpno.length; ++index) {
                                console.log(o.openvpno[index]);
                                line = o.openvpno[index].split(' ');
                                this.openvpnObj.push('--'+line[0]);

                                if(line[1]) {
                                        this.openvpnObj.push(line[1]);
                                }
                                if(line[2]) {
                                        this.openvpnObj.push(line[2]);
                                }
                                if(line[3]) {
                                        this.openvpnObj.push(line[3]);
                                }
                                console.log('openvpnobj' + this.openvpnObj);
                        }
                    }
                if(this.obfs) {
                        obfsproxy = true;
                        console.log('launch shapeshifter');
                        spawn('sudo', ['route','add', '-host', server, 'gw', gateway]);
                        this.openvpnObj.push('--socks-proxy', '127.0.0.1', '1050');
                        this.openvpnObj.push('--connect-retry-max', '3');
                        if(shapeenable  == true) {
                            console.log('./lib/bin/linux/shapeshifter-dispatcher -transparent -client -state state -target ' +server+':21195 -transports obfs4 -bindaddr obfs4-127.0.0.1:1050 -options "{\\\"cert\\\": \\\"kl4vvmBNXW3Uh4KJfAJslq365OM94WfEO3rTii2Z2P6CnW0aj//4FPJJzmaDWWH/CCw1WA\\\", \\\"iatMode\\\": \\\"0\\\"}" -logLevel DEBUG -enableLogging -proxylistenaddr 127.0.0.1:1050')
                            exec('./lib/bin/linux/shapeshifter-dispatcher -transparent -client -state state -target ' +server+':21195 -transports obfs4 -bindaddr obfs4-127.0.0.1:1050 -options "{\\\"cert\\\": \\\"kl4vvmBNXW3Uh4KJfAJslq365OM94WfEO3rTii2Z2P6CnW0aj//4FPJJzmaDWWH/CCw1WA\\\", \\\"iatMode\\\": \\\"0\\\"}" -logLevel DEBUG -enableLogging -proxylistenaddr 127.0.0.1:1050', function(error, stdout, stderr) {
                                if (error !== null) {
                                    console.log('exec error: ' + error);
                                }
                            });
                        } else {
                            spawn('obfsproxy',  ['--log-min-severity=info', 'obfs2', 'socks', '127.0.0.1:1050']);
                        }
                }
                if(this.ipv6) {
                    ipv6disabled = true;
                    spawn('sudo', ['sysctl','-w', 'net.ipv6.conf.all.disable_ipv6=1'])
                    spawn('sudo', ['sysctl', '-w', 'net.ipv6.conf.default.disable_ipv6=1'])
                    spawn('sudo', ['sysctl','-p'])                   
                    //spawn('sudo', ['route','add', '-host', server, 'gw', gateway]);
                }
                if(this.dnsleakfix) {
                            this.openvpnObj.push('--script-security', '2');
                            this.openvpnObj.push('--up', this.dir+'/bin/linux/update-resolve.sh');
                            this.openvpnObj.push('--down', this.dir+'/bin/linux/update-resolve.sh');
                }
                spawn('sudo', ['chmod', '+x', './lib/bin/linux/update-resolve.sh']);
                this.openvpns = spawn('sudo', this.openvpnObj);
            break;
            
            case 'darwin':
                //no Admin
                //spawn('sudo', ['chown', '-R', 'root:wheel', './lib/bin/osx/tun.kext']);
                //spawn('sudo', ['/sbin/kextload', './lib/bin/osx/tun.kext']);
                spawn('sudo', ['chmod', '+x', './lib/bin/osx/openvpn']);
                spawn('sudo', ['chmod', '+x', './lib/bin/osx/obfsproxy']);
                spawn('sudo', ['chmod', '+x', './lib/bin/osx/client.up.sh']);
                spawn('sudo', ['chmod', '+x', './lib/bin/osx/client.down.sh']);
                if(this.openvpnno) {
                        console.log('openvpn options');
                        var index;
                        for (index = 0; index < o.openvpno.length; ++index) {
                                console.log(o.openvpno[index]);
                                line = o.openvpno[index].split(' ');
                                this.openvpnObj.push('--'+line[0]);

                                if(line[1]) {
                                        this.openvpnObj.push(line[1]);
                                }
                                if(line[2]) {
                                        this.openvpnObj.push(line[2]);
                                }
                                if(line[3]) {
                                        this.openvpnObj.push(line[3]);
                                }
                                console.log('openvpnobj' + this.openvpnObj);
                        }
                    }
                    if(this.ipv6) {
                        ipv6disabled = true;
                        exec(ipv6off);
                    }
                    if(this.obfs) {
                        obfsproxy = true;
                        spawn('sudo', ['route','add', '-host', server, gateway]);
                        
                       
                        if(shapeenable  == true) {
                            exec('./lib/bin/osx/shapeshifter-dispatcher -transparent -client -state state -target ' +server+':21195 -transports obfs4 -bindaddr obfs4-127.0.0.1:1050 -options "{\\\"cert\\\": \\\"kl4vvmBNXW3Uh4KJfAJslq365OM94WfEO3rTii2Z2P6CnW0aj//4FPJJzmaDWWH/CCw1WA\\\", \\\"iatMode\\\": \\\"0\\\"}" -logLevel DEBUG -enableLogging -proxylistenaddr 127.0.0.1:1050', function(error, stdout, stderr) {
                                if (error !== null) {
                                    console.log('exec error: ' + error);
                                }
                            });
                        } else {
                            this.openvpnObj.push('--socks-proxy', '127.0.0.1', '1050');
                            this.openvpnObj.push('--connect-retry-max', '3');
                            spawn('./lib/bin/osx/obfsproxy',  ['--log-min-severity=info', 'obfs2', 'socks', '127.0.0.1:1050']);
                        }
                    }
                 this.openvpns = {};
                 this.openvpns = spawn('sudo', this.openvpnObj);
            break;
            case 'win32':

                if(this.openvpnno) {
                    console.log('openvpn options');
                    var index;
                    for (index = 0; index < o.openvpno.length; ++index) {
                        console.log(o.openvpno[index]);
                         if(this.dnsleakfix) {
                            if(o.openvpno[index] == 'ip-win32 ipapi') {

                            } else {
                                line = o.openvpno[index].split(' ');
                                this.openvpnObj.push('--'+line[0]);
                                if(line[1]) {
                                    this.openvpnObj.push(line[1]);
                                }
                                if(line[2]) {
                                    this.openvpnObj.push(line[2]);
                                }
                                if(line[3]) {
                                    this.openvpnObj.push(line[3]);
                                }
                            }
                        } else {

                            line = o.openvpno[index].split(' ');
                            this.openvpnObj.push('--'+line[0]);

                            if(line[1]) {
                                this.openvpnObj.push(line[1]);
                            }
                            if(line[2]) {
                                this.openvpnObj.push(line[2]);
                            }
                            if(line[3]) {
                                this.openvpnObj.push(line[3]);
                            }
                        }

                    }

                    if(this.ipv6) {
                        ipv6disabled = true;
                        spawn('netsh', ['interface', 'teredo', 'set', 'state', 'disabled']);
                        spawn('netsh', ['interface', 'ipv6', '6to4', 'set', 'state', 'disabled', 'undoonstop=disabled']);
                        spawn('netsh', ['interface', 'ipv6', 'isatap', 'set', 'state','disabled']);
                    }
                    if(this.obfs) {
                        obfsproxy = true;
                        //console.log('launching stealth vpn');
                        //console.log('\\bin\\windows\\obfs\\shapeshifter-dispatcher.exe -transparent -client -state state -target au4.vpnsecure.me:21195 -transports obfs4 -bindaddr obfs4-127.0.0.1:1050 -options "{\\\"cert\\\": \\\"kl4vvmBNXW3Uh4KJfAJslq365OM94WfEO3rTii2Z2P6CnW0aj//4FPJJzmaDWWH/CCw1WA\\\", \\\"iatMode\\\": \\\"0\\\"}" -logLevel DEBUG -enableLogging -proxylistenaddr 127.0.0.1:1050')
                        if(shapeenable  == true) {
                            exec('"'+this.dir+'\\bin\\windows\\obfs\\'+shapes+'" -transparent -client -state state -target ' +server+':21195 -transports obfs4 -bindaddr obfs4-127.0.0.1:1050 -options "{\\\"cert\\\": \\\"kl4vvmBNXW3Uh4KJfAJslq365OM94WfEO3rTii2Z2P6CnW0aj//4FPJJzmaDWWH/CCw1WA\\\", \\\"iatMode\\\": \\\"0\\\"}" -logLevel DEBUG -enableLogging -proxylistenaddr 127.0.0.1:1050', function(error, stdout, stderr) {
                                if (error !== null) {
                                    console.log('exec error: ' + error);
                                }
                            });  
                        } else {
                            this.openvpnObj.push('--connect-retry-max', '3');
                            this.openvpnObj.push('--socks-proxy', '127.0.0.1', '1050');
                            spawn(this.dir+'\\bin\\windows\\obfs\\obfsproxy.exe',  ['--log-min-severity=info', 'obfs2', 'socks', '127.0.0.1:1050']);   
                        } 
                    }
                    if(this.dnsleakfix) {
                            this.openvpnObj.push('--plugin', this.dir+'\\bin\\windows\\block-incoming-udp-'+pltArch+'.dll');
                            this.openvpnObj.push('--block-outside-dns');
                    }
                    console.log('openvpnobj' + this.openvpnObj);
                }

                this.openvpns = {};
                if(pltArch == 64) {
                    this.openvpns = spawn(this.dir+'\\bin\\windows\\openvpn.exe', this.openvpnObj);
                }if(pltArch == 32) {
                    this.openvpns = spawn(this.dir+'\\bin\\windows\\openvpn32\\openvpn.exe', this.openvpnObj);
                }
              
            break;
        }
        console.log('connecting');
        setupEvents(this);
    };
};

function wait(ms){
   var start = new Date().getTime();
   var end = start;
   while(end < start + ms) {
     end = new Date().getTime();
  }
}
function setupEvents(self) {
    console.log('setupEvents');
    var result;
    var t =0;
    var cachedPassword = null;
    var prompts = 0;
    apiip = self.apiip;
    if(self.updnsleak) {
        self.updnsleak.on('close', function(data) {
            console.log('updnsleak close even hit');
            self.updnsleak.kill();
        });
    }
    self.openvpns.stderr.on("data", function(data){
        console.log("stderr: " + data.toString("utf8"));
    });
    self.openvpns.stdout.on('data', function(data) {
        var pid = self.openvpns.pid;
        window.localStorage['opid'] = pid;
        //console.log('waiting for data');

        var ok = false;
        if(!data) throw err;
        var line = data.toString().replace(/vpnsecure/gi, packageInfo.brand).replace(/^.*WARNING: file .*$/mg, "").replace(/^.*NOTE: the current .*$/mg, "")
        openvpnLogFile.write(line+'\r');
        if(line.indexOf("received, process restarting") >1) {
                  keypassword = true;
                  wait(1000);
        }
         if(line.indexOf("No buffer space available (WSAENOBUFS) (code=10055)") >1) {
                  keypassword = true;
                  wait(1000);
        } else {
          if(self.connected) {
              return self.emit('data', data);
            }
        }
        //Start Log parsing for errors and success;
        if(line.indexOf('Warning: route gateway is not reachable on any active network') >1) {
            self.emit('routegateway');
        }
        if(line.indexOf('default_up.bat') >1) {
            self.emit('setting_dnsleak');
        }
        if(line.indexOf('default_down.bat') >1) {
            self.emit('removing_dnsleak');
        }
        if(line.indexOf('Notified TAP-Win32 driver to set a DHCP') >1) {
            vpnip = line.split(" ");
            vpnip = vpnip[17];
            console.log('VPNIP -'+ vpnip);
        }
        if(line.indexOf('Notified TAP-Windows driver to set a DHCP') >1) {
            tapid = line.split(" ");
            tapid = tapid[19];
            console.log('TAPID -'+ tapid);
        }
        if(line.indexOf('TCP/UDP: Closing Socket') > 1) {
            self.emit('exit');
        }
        if(line.indexOf('TLS Error: TLS object -> incoming plaintext read error') > 1) {
            self.emit('failed_connect');
            self.emit('exit');
        }
        /* Disable renaming of the tap adapter, this maybe causing issues */
         if(line.indexOf('All TAP-Windows adapters on this system are currently in use') >1) {
                if(ostype == "win32") {
                    tunnelname = spawn('wmic', ['nic', 'get', 'name,NetConnectionID']);
                    Lazy(tunnelname.stdout).lines.map(String).skip(2).map(function (line) {
                                var fields = line.trim().split("\\r");
                                fields.forEach(function (x) {
                                        if(x.indexOf("TAP-Windows") > -1) {
                                            nicIndex = x.split("V9")[1].trim();
                                            window.console.log('tapadapater');
                                            tapAdapater(nicIndex,'disable', function(data) {
                                                if(data) {
                                                    tapAdapater(nicIndex,'enable', function(data) {
                                                        if(data) {
                                                            self.emit('fixed_tap_dapater');
                                                            self.emit('exit');
                                                        } else {
                                                             self.emit('exit');
                                                        }
                                                    });
                                                }
                                            });

                                        }
                                });
                    });
                }
        } else {

        }
        if(line.indexOf("There are no TAP-Windows adapters on this system") >1) {
           
            disconnectOpenVPN();
            keypassword=false;
            return self.emit('notapdriver')
        }
        if(line.indexOf('Exiting due to fatal error') >1) {
            disconnectOpenVPN();
            keypassword=false;
            return self.emit('tuntap');
        }
        if(line.indexOf("I am having trouble using the Windows 'IP helper API' to automatically set the IP address") > 1) {
            disconnectOpenVPN();
            keypassword=false;
            return self.emit('remove_ipwin32');
            
        }
        if(line.indexOf('failed, will try again in 5 seconds: Connection refused') > 1) {
            self.emit('failed_connect');
        }
        if(line.indexOf('will try again in 5 seconds: Connection timed out') > 1) {
            self.emit('failed_connect');
        }
        if(line.indexOf('Connection reset, restarting [-1]') >1) {
             self.emit('networkunreach');
        }
         if(line.indexOf('Connection reset, restarting [0]') >1) {
             self.emit('networkunreach');
        }
        if(line.indexOf('Pause for configuration changes to be propagated to State') > 1) {
            self.emit('setting_routes');
        }
        if(line.indexOf('UDPv4 link remote:') > 1) {
            self.emit('attempt_establish_udp');
        }
        if(line.indexOf('BIO routines:FILE_CTRL:system lib: error') > 1) {
            disconnectOpenVPN();
            keypassword=false;
            return self.emit('keyfileerror');
        }
        if(line.indexOf('Attempting to establish TCP connection with') > 1) {
            self.emit('attempt_establish_tcp');
        }
        if(line.indexOf('TCP connection established with') > 1) {
            self.emit('tcp_established');
        }

        if(line.indexOf('VERIFY OK: depth=1') > 1) {
            self.emit('verifykeys');
        }
        if(line.indexOf('Data Channel Encrypt:') >1) {
            self.emit('encryptdatachannel');
        }
        if(line.indexOf('SIGTERM[hard,] received, process exiting') >1) {
            disconnectOpenVPN();
            keypassword=false;
            return self.emit('close');
        }
        if(line.indexOf('All connections have been connect-retry-max (2) times unsuccessful, exiting') >1) {
            disconnectOpenVPN();
            keypassword = false;
            switch(self.ostype) {
                case 'linux':
                    spawn('sudo', ['killall', 'openvpn']);
                break;
                case 'darwin':
                    spawn('sudo', ['killall', 'openvpn']);
                break;
                case 'win32':
                    spawn('taskkill', ['/F', '/IM', 'openvpn.exe']);
                break
            }

            return self.emit('bind');

        }
        if(line.indexOf('Windows route add command failed') >1) {
            console.log('bind fail');
            //spawn('sudo',['kill', '-9', 'openvpn']);
              disconnectOpenVPN();
              keypassword=false;
              return  self.emit('routecommandfailed');
        }
        if(line.indexOf('MANAGEMENT: Socket bind failed on local address 127.0.0.1') >1) {
            console.log('bind fail');
            disconnectOpenVPN();
            keypassword=false;
            switch(self.ostype) {
                case 'linux':
                    spawn('sudo', ['killall', 'openvpn']);
                break;
                case 'darwin':
                    spawn('sudo', ['killall', 'openvpn']);
                break;
                case 'win32':
                    spawn('taskkill', ['/F', '/IM', 'openvpn.exe']);
                break
            }

            return self.emit('bind');
            //spawn('sudo',['kill', '-9', 'openvpn']);

            //self.emit('exit');
        }
        if(line.indexOf('WSAECONNRESET') > 1) {
                disconnectOpenVPN();
                keypassword=false;
                return self.emit('WSAECONNRESET');

        }
        if(line.indexOf('ERROR: Linux route add command failed: external program exited with error status') >1) {
                disconnectOpenVPN();
                keypassword=false;
                return self.emit('externalscriptfail');
        }
        if(line.indexOf('ERROR: Linux route add command failed') > 1) {
                disconnectOpenVPN();
                keypassword=false;
                return self.emit('routecommandfailed');
        }
        if(line.indexOf('TLS Error: TLS key negotiation failed to occur within 60 seconds') > 1) {
                disconnectOpenVPN();
                keypassword=false;
                return self.emit('failed_connect');
        }
        if(line.indexOf('AUTH_FAILED') > 1) {

                return self.emit('authfailed');
        }
        if(line.indexOf('Cannot load certificate file') > 1) {
                disconnectOpenVPN();
                keypassword=false;
                return self.emit('certificatefileerror');
        }
        if(line.indexOf('Error: private key password verification failed') > 1) {
                disconnectOpenVPN();
                keypassword=false;
                return self.emit('keypassword');
        }
        if(line.indexOf("Network is unreachable") >1) {
                return self.emit('networkunreach');
        }

        if(line.indexOf("VERIFY ERROR: depth=1, error=certificate is not yet valid:") >1) {
                return self.emit('systemdate');

        }
        if(line.indexOf("Options error: Unrecognized option or missing parameter") > 1) {
                return self.emit("exit");
        }
        if(line.indexOf("[ECONNREFUSED]: Connection refused") > 1) {
                return self.emit("exit");
        }
        if(line.indexOf("Closing TUN/TAP interface") > 1) {
                return self.emit("exit");
        }
        if(line.indexOf("TUN/TAP I/O operation aborted, restarting") > 1) {
                disconnectOpenVPN();
                keypassword=false;
                return self.emit('completedwitherrors');
        }
        if(line.indexOf("Initialization Sequence Completed With Errors") > 1) {

                disconnectOpenVPN();
                keypassword=false;
                return self.emit('completedwitherrors');
        }
        if(line.indexOf("Cannot allocate TUN/TAP dev dynamically") >1) {
                return self.emit('tuntap');
        }
        //console.log(result);
        if(line.indexOf("Initialization Sequence Completed") > 1) {
                self.connected = true;
                connectingopenvpn = false;

                self.emit('connected', self.config);
                return self.emit('data',data);
        }

        if(keypassword) {
                keypassword = false;
                socketconn = true;
                console.log('starting socket to openvpn daemon');

                    createOpenVPNConnection(function(data) {
                        if(data) {
                            if(!socketconn) {
                                console.log('private key');
                            }
                        }
                    });
        }
    });
    self.openvpns.on('uncaughtException', function (err) {
        console.log('uncaught');
        if(err) {
            self.emit("exit");
        }
    });

    self.openvpns.on("exit", function (err) {
        console.log('OpenVPN exiting', err);
        self.connected=false;
        connectingopenvpn = false;
        self.removeAllListeners('data');
        self.openvpns.stdout.removeAllListeners('data');
        self.openvpns.removeAllListeners('data');
        self.openvpns.removeAllListeners('uncaughtException');
        keypassword=false;
        if(obfsproxy == true) {
            obfsproxy = false;
            switch(ostype) {
                case 'linux':
                    spawn('sudo', ['killall', 'obfsproxy']);
                    spawn('sudo', ['killall', 'obfsproxy']);
                    spawn('sudo', ['killall', 'shapeshifter-dispatcher']);
                    spawn('sudo', ['route','del', '-host', server]);
                break;
                case 'darwin':
                    console.log('starting obfsproxy kill process');
                    spawn('sudo', ['route','delete', '-host', server, gateway]);
                    spawn('sudo', ['killall', 'shapeshifter-dispatcher']);
                    spawn('sudo', ['killall', 'obfsproxy']);
                break;
                case 'win32':
                console.log('should kill shapes' + shapes);
                    spawn('taskkill', ['/F', '/IM', shapes]);
                    spawn('taskkill', ['/F', '/IM', 'obfsproxy.exe']);
                break
            }
        }
        console.log(self.protect);
        if(self.protect) {
            switch(ostype) {
                case 'linux':
                    spawn('sudo', ['route', 'delete', 'default']);
                    spawn('sudo', ['route', 'add', '-host', apiip, 'gw', self.gateway]);
                break;
                case 'win32':
                        console.log('hit protect on disconnect');
                        /* spawn(self.dir+'\\bin\\windows\\protect.bat', ['true', self.gateway, apiip]); */
                        spawn('route.exe', ['delete', '0.0.0.0', 'mask', '0.0.0.0', self.gateway]);
                        spawn('route.exe', ['add', apiip, 'mask', '255.255.255.255', self.gateway]);
                break;
                case 'darwin':
                        
                        spawn('sudo', ['route', 'delete', 'default']);
                        spawn('sudo', ['route', 'add', '-net', apiip, '-gateway', self.gateway]);
                break;
            }
            self.interDisable = true;

        }

        return self.emit('close');
    });

    self.openvpns.on("error", function(err) {
        console.log('Internal Error' + err);
        self.emit("exit");
    });
}
function tapAdapater(nicIndex,type, cb) {
    console.log('hit TapAdapter function');
     if(type == 'disable') {
        console.log('hit tap disable');
        disabletun = spawn('netsh', ['interface', 'set', 'interface', ""+nicIndex+"", "admin=disable"]);
        disabletun.on('close', function() {
            return cb(true);
        });
     }
     if(type == 'enable') {
         console.log('hit tap enable');
         //origin = ""
         newname = "tap3"
         enabletun = spawn('netsh', ['interface', 'set', 'interface', ""+nicIndex+"", "admin=enable"]);
         enabletun.on('close', function() {
             //renametun = spawn('netsh', ['interface', 'set', 'interface name', ""+nicIndex+"" "newname", ""newname""])
             //renametun.on('close', function() {
             //   return cb(true);
            //});
        return cb(true);

        });
    }
}
function createOpenVPNConnection(cb) {
        cb(true)
}

function privateKey(pass, cb) {
    //telo.socket.write('password "Private Key" "' + pass + '"\r\n', function() {keypassword = false;});
    return cb(true)
}
function checkLogfile() {
    var i;
    var count = 0;
    require('fs').createReadStream(path + '/openvpn.log')
    .on('data', function(chunk) {
    for (i=0; i < chunk.length; ++i)
      if (chunk[i] == 10) count++;
  })
  .on('end', function() {
      if(count > 600) {
        fs.truncate(path + '/openvpn.log', 0, function(err){ console.log(err); });
      }
  });
}
function disconnectOpenVPN() {
    switch(ostype) {
        case 'linux':
            spawn('sudo', ['killall', 'openvpn']);
            spawn('sudo', ['route','del', '-host', server]);
            keypassword = false;
            socketconn = true;
        break;
        case 'darwin':
            console.log('starting openvpn kill process');
            spawn('sudo', ['route','delete', '-host', server, gateway]);
            spawn('sudo', ['killall', 'openvpn']);
        break;
        case 'win32':
            console.log('should kill shapes' + 'openvpn.exe');
            spawn('taskkill', ['/F', '/IM', 'openvpn.exe']);
        break;
    }
    if(obfsproxy == true) {
        obfsproxy = false;

        switch(ostype) {
            case 'linux':
                spawn('sudo', ['killall', 'shapeshifter-dispatcher']);
                spawn('sudo', ['route','del', '-host', server]);
                spawn('sudo', ['killall', 'obfsproxy']);
            break;
            case 'darwin':
                console.log('starting obfsproxy kill process');
                spawn('sudo', ['route','delete', '-host', server, gateway]);
                spawn('sudo', ['killall', 'shapeshifter-dispatcher']);
                spawn('sudo', ['killall', 'obfsproxy']);
            break;
            case 'win32':
            console.log('should kill shapes' + shapes);
                spawn('taskkill', ['/F', '/IM', shapes]);
                spawn('taskkill', ['/F', '/IM', 'obfsproxy.exe']);
            break;
        }
    }
    if(ipv6disabled == true) {
        ipv6disabled = false;
        switch(ostype) {
            case 'linux':
                spawn('sudo', ['sysctl','-w', 'net.ipv6.conf.all.disable_ipv6=0'])
                spawn('sudo', ['sysctl', '-w', 'net.ipv6.conf.default.disable_ipv6=0'])
                spawn('sudo', ['sysctl','-p'])      
            break;
            case 'darwin':
                 exec(ipv6on);
            break;
            case 'win32':
                 spawn('netsh', ['interface', 'teredo', 'set', 'state', 'type=default']);
                 spawn('netsh', ['interface', 'ipv6', '6to4', 'set', 'state', 'state=enabled', 'undoonstop=enabled']);
                 spawn('netsh', ['interface', 'ipv6', 'isatap', 'set', 'state','state=enabled']);
            break;
        }
    }
    keypassword = false;
    socketconn = true;
}

function getDomainIP(hostname, cb) {
       dns.lookup(hostname, function (err, add, fam) {
           if (err)
           {
                    console.log("The error = ", JSON.stringify(err));
                    return cb(false);
           }
           return cb(add);
       });
}

require('util').inherits(OpenvpnClient, require('events').EventEmitter);
module.exports=OpenvpnClient;
exports = disconnectOpenVPN;
